<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN" "http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="mhp.oee.dao.extend.ResourcePlcInfoAndResrceAndPlcAccessTypePOMapper">
  <resultMap id="BaseResultMap" type="mhp.oee.po.extend.ResourcePlcInfoAndResrceAndPlcAccessTypePO">
    <id column="ID" jdbcType="VARCHAR" property="id" />
    <result column="HANDLE" jdbcType="VARCHAR" property="handle" />
    <result column="SITE" jdbcType="VARCHAR" property="site" />
    <result column="RESOURCE_BO" jdbcType="VARCHAR" property="resourceBo" />
    <result column="PLC_IP" jdbcType="VARCHAR" property="plcIp" />
    <result column="PLC_PORT" jdbcType="VARCHAR" property="plcPort" />
    <result column="PLC_ACCESS_TYPE" jdbcType="VARCHAR" property="plcAccessType" />
    <result column="CREATED_DATE_TIME" jdbcType="TIMESTAMP" property="createdDateTime" />
    <result column="MODIFIED_DATE_TIME" jdbcType="TIMESTAMP" property="modifiedDateTime" />
    <result column="MODIFIED_USER" jdbcType="VARCHAR" property="modifiedUser" />
    <result column="PC_IP" jdbcType="VARCHAR" property="pcIp" />
    <association property="plcAccessTypePO" column="plcAccessType" javaType="mhp.oee.po.gen.PlcAccessTypePO">
        <id column="HANDLE" jdbcType="VARCHAR" property="handle" />
        <result column="SITE" jdbcType="VARCHAR" property="site" />
        <result column="PLC_ACCESS_TYPE" jdbcType="VARCHAR" property="plcAccessType" />
        <result column="C_DESCRIPTION" jdbcType="VARCHAR" property="description" />
    </association>
    <association property="resourcePO" column="handle" javaType="mhp.oee.po.gen.ResourcePO">
        <id column="RESROURCE_BO" jdbcType="VARCHAR" property="handle" />
        <result column="SITE" jdbcType="VARCHAR" property="site" />
        <result column="RESRCE" jdbcType="VARCHAR" property="resrce" />
        <result column="A_DESCRIPTION" jdbcType="VARCHAR" property="description" />
        <result column="LINE_AREA" jdbcType="VARCHAR" property="lineArea" />
        <result column="WORK_AREA" jdbcType="VARCHAR" property="workArea" />
        <result column="WORKSHOP" jdbcType="VARCHAR" property="workshop" />
        <result column="ENABLED" jdbcType="VARCHAR" property="enabled" />
    </association>
  </resultMap>
  <select id="selectResPlcInfoAndResrceAndPlcAccessType" resultMap="BaseResultMap">
	SELECT 
	(@rowNum:=@rowNum+1) as ID,
	B.*,
	A.HANDLE AS RESROURCE_BO,
	A.RESRCE,
	A.DESCRIPTION AS A_DESCRIPTION,
	C.DESCRIPTION AS C_DESCRIPTION,
	C.PLC_ACCESS_TYPE
	FROM RESRCE as A
	LEFT JOIN RESOURCE_PLC_INFO AS B ON A.HANDLE=B.RESOURCE_BO
	LEFT JOIN PLC_ACCESS_TYPE AS C ON B.PLC_ACCESS_TYPE = C.PLC_ACCESS_TYPE AND
	B.SITE = C.SITE
	WHERE 1=1 AND A.SITE = #{plcInfoConditionVO.site}
	<if test="plcInfoConditionVO.hasResource == 'true' ">
		AND A.RESRCE IN
		<foreach close=')' collection='plcInfoConditionVO.resource'
			item='res' open='(' separator=','>
			#{res}
		</foreach>
	</if>
	<if test="plcInfoConditionVO.hasResource == 'false' ">
		AND A.RESRCE IN
		<foreach close=')' collection='resSet' item='res' open='('
			separator=','>
			#{res}
		</foreach>
	</if>
	ORDER BY A.HANDLE
	<if test="plcInfoConditionVO.limit != null">
		<if test="plcInfoConditionVO.offset != null">
			limit ${plcInfoConditionVO.offset}, ${plcInfoConditionVO.limit}
		</if>
		<if test="plcInfoConditionVO.offset == null">
			limit ${plcInfoConditionVO.limit}
		</if>
	</if>
</select>
<select id="selectResPlcInfoAndResrceAndPlcAccessTypeCount" resultType="java.lang.Integer">
	SELECT COUNT(*) FROM RESRCE as A
	LEFT JOIN RESOURCE_PLC_INFO AS B ON A.HANDLE=B.RESOURCE_BO
	LEFT JOIN PLC_ACCESS_TYPE AS C ON B.PLC_ACCESS_TYPE = C.PLC_ACCESS_TYPE AND
	B.SITE = C.SITE
	WHERE 1=1 AND A.SITE = #{plcInfoConditionVO.site}
	<if test="plcInfoConditionVO.hasResource == 'true' ">
		AND A.RESRCE IN
		<foreach close=')' collection='plcInfoConditionVO.resource'
			item='res' open='(' separator=','>
			#{res}
		</foreach>
	</if>
	<if test="plcInfoConditionVO.hasResource == 'false' ">
		AND A.RESRCE IN
		<foreach close=')' collection='resSet' item='res' open='('
			separator=','>
			#{res}
		</foreach>
	</if>
</select>
</mapper>